/*
 * Security Ninja - Malware Scanner add-on
 * (c) 2018. Web factory Ltd
 */

;jQuery(document).ready(function($){
  // toggle file info details
  $('#sn_ms_results').on('click', '.sn-malware-title', function(e){
    e.preventDefault();

    content = $(this).parents('.sn-malware-filebox').find('.sn-malware-file-code');

    $('.toggle-slide', this).toggleClass('opened');
    $(content).slideToggle(500);
  }); // toggle
  

  // run test
  $('#sn_ms_run_scan').on('click', function(e) {
    e.preventDefault();

    startingpoint = $.Deferred();
    startingpoint.resolve();

    $('#sn_ms_results').html('');
    $('ul.malware-scan-list').html('');
    $('.wrap .error').hide();

    $.each(actions, function(i, action) {
      $('ul.malware-scan-list').append('<li id="msg_' + action.action +'" class="pending">' + action.msg1 + ' <span class="badge">Waiting ...</span></li>');
    });
    $('.loader').hide();

    sn_block_ui('#sn-malware-scanner');

    $.each(actions, function(i, action) {
      startingpoint = startingpoint.pipe( function() {
        $('#msg_' + action.action).removeClass('pending').addClass('current');
        $('.badge', '#msg_' + action.action).html('Working ...');
        return do_sn_ms_request(action);
      });
    }); // each action
    
    $('.wf-sn-ms-not-run').hide();
  }); // run tests

  
  // handle each individual ajax call
  function do_sn_ms_request(params) {
    return $.ajax({ type: 'POST',
      url: ajaxurl,
      data: {action: 'sn_ms_run_scan', what: params.action, _ajax_nonce: wf_sn_ms_nonce},
      dataType: 'json',
      success: function(response) {
        if (!response.success) {
          alert('Invalid option. Please reload');
          return;
        }

        $('#msg_' + params.action).removeClass('pending').removeClass('current').addClass('passed');
        $('.badge', '#msg_' + params.action).html(params.msg2.replace('%d', parseInt(response.data.cnt, 10)));

        if (params.action == 'get_results') {
          $('#sn_ms_results').append(response.data);
          sn_unblock_ui('#sn-malware-scanner');
          $('.loader').show();
        }
      }, // success
      error: function(response){
        alert('An undocumented error has occured. Please reload the page and try again.');
      } // error
    });
  } // do_sn_ms_request

  
var actions = [{msg1: 'Cleaning cache ... ', msg2: ' DONE!', action: 'clean_cache'},

               {msg1: 'Generating list of wp_options table rows ... ', msg2: 'DONE! Found %d rows.', action: 'get_db_rows'},
               {msg1: 'Generating list of theme folders ... ', msg2: 'DONE! Found %d folders.', action: 'get_theme_folders'},
               {msg1: 'Generating list of plugin folders ... ', msg2: 'DONE! Found %d folders.', action: 'get_plugin_folders'},
               {msg1: 'Generating list of wp-content folders ... ', msg2: 'DONE! Found %d folders.', action: 'get_content_folders'},

               {msg1: 'Generating list of theme files ... ', msg2: 'DONE! Found %d files.', action: 'get_theme_files'},
               {msg1: 'Generating list of plugin files ... ', msg2: 'DONE! Found %d files.', action: 'get_plugin_files'},
               {msg1: 'Generating list of wp-content files ... ', msg2: 'DONE! Found %d files.', action: 'get_content_files'},

               {msg1: 'Scanning wp_options table ... ', msg2: 'DONE! Found %d suspicious rows.', action: 'scan_db'},
               {msg1: 'Scanning theme files ... ', msg2: 'DONE! Found %d suspicious files.', action: 'scan_theme_files'},
               {msg1: 'Scanning plugin files ... ', msg2: 'DONE! Found %d suspicious files.', action: 'scan_plugin_files'},
               {msg1: 'Scanning wp-content files ... ', msg2: 'DONE! Found %d suspicious files.', action: 'scan_content_files'},

               {msg1: 'Generating results ... ', msg2: 'DONE!', action: 'get_results'}];

}); // onload
